
#include <AT89X51.H>
#include "Keypad.h"

// Pin definition
// for telephone 
// keypad.
sbit ROW0 = P1^0;
sbit ROW1 = P1^1;
sbit ROW2 = P1^2;
sbit ROW3 = P1^3;

sbit COL0 = P1^4;
sbit COL1 = P1^5;
sbit COL2 = P1^6;

char kgetkey()
{
	static unsigned char Ctr = 0;
	static char PrevKey = -1;
	char Result = -1;
	unsigned char r, c;
	for(r = 0; r < 4; r ++)
	{
		ROW0 = ROW1 = ROW2 = ROW3 = 1;
		switch(r)
		{
		case 0:		
			ROW0 = 0;	
			for(c = 0; c < 3; c ++)
			{
				switch(c)
				{
				case 0:	if(COL0 == 0) Result = '1';		break;
				case 1:	if(COL1 == 0) Result = '2';		break;
				case 2:	if(COL2 == 0) Result = '3';		break;
				}
			}
			break;
		case 1:		
			ROW1 = 0;	
			for(c = 0; c < 3; c ++)
			{
				switch(c)
				{
				case 0:	if(COL0 == 0) Result = '4';		break;
				case 1:	if(COL1 == 0) Result = '5';		break;
				case 2:	if(COL2 == 0) Result = '6';		break;
				}
			}
			break;
		case 2:		
			ROW2 = 0;	
			for(c = 0; c < 3; c ++)
			{
				switch(c)
				{
				case 0:	if(COL0 == 0) Result = '7';		break;
				case 1:	if(COL1 == 0) Result = '8';		break;
				case 2:	if(COL2 == 0) Result = '9';		break;
				}
			}
			break;
		case 3:		
			ROW3 = 0;	
			for(c = 0; c < 3; c ++)
			{
				switch(c)
				{
				case 0:	if(COL0 == 0) Result = '*';		break;
				case 1:	if(COL1 == 0) Result = '0';		break;
				case 2:	if(COL2 == 0) Result = '#';		break;
				}
			}
			break;
		}
	}
	if(PrevKey == Result)
	{
		if(Ctr < 18)
			Ctr ++;
   	}
	else
		Ctr = 0;
	PrevKey = Result;
	
	if(Ctr == 17)
	{
		return Result;
	}
	else
		return -1;
}

char kgetch()
{
	char Key = -1;
	while(Key == -1)
		Key = kgetkey();
	return Key;
}

